<?php

namespace CRM\Controller;

use Zeedhi\Framework\DTO\Request;
use CRM\Traits\TResponse;
use CRM\Service\CrmCargoService;

class CrmCargoController
{
    protected $CargoService;

    use TResponse;

    public function __construct(CrmCargoService $CrmCargoService)
    {
        $this->CargoService = $CrmCargoService;
    }

    public function getCrmCargo()
    {
        try {
            $data = $this->CargoService->getCrmCargo();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveCrmCargo(Request $request)
    {
        try {
            $rows = $request->getParameters();
            $data = $this->CargoService->saveCrmCargo($rows);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function deleteCrmCargo(Request $request)
    {
        try {
            $rows = $request->getParameters();
            $data = $this->CargoService->deleteCrmCargo($rows);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
      
        }  
    }
}