<?php

namespace CRM\Controller;

use Zeedhi\Framework\DTO\Request;
use CRM\Traits\TResponse;
use CRM\Service\CrmFaseDeNegociacaoService;

class CrmFaseDeNegociacaoController
{
    protected $CrmFaseDeNegociacaoService;

    use TResponse;

    public function __construct(CrmFaseDeNegociacaoService $CrmFaseDeNegociacaoService)
    {
        $this->CrmFaseDeNegociacaoService = $CrmFaseDeNegociacaoService;
    }

    public function getNegotiationPhase()
    {
        try {
            $data = $this->CrmFaseDeNegociacaoService->getNegotiationPhaseService();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveNegotiationPhase(Request $request)
    {
        try {
            $rows = $request->getParameters();
            $this->CrmFaseDeNegociacaoService->saveNegotiationPhaseService($rows);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteNegotiationPhase(Request $request)
    {
        try {
            $rows = $request->getParameters();
            $this->CrmFaseDeNegociacaoService->deleteNegotiationPhase($rows);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}