<?php

namespace CRM\Controller;

use CRM\Util\Utilities;
use CRM\Traits\TResponse;
use CRM\Service\LeadService;
use Zeedhi\Framework\DTO\Request;

class LeadController
{

    protected $LeadService;

    use TResponse;

    public function __construct(LeadService $LeadService)
    {
        $this->LeadService = $LeadService;
    }

    public function getLoggedOperator()
    {
        try {
            $data = $this->LeadService->getCdOperador();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getResponsibleOperator(Request $request)
    {
        try {
            $data = $this->LeadService->getResponsibleOperator($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getMarketSegment()
    {
        try {
            $data = $this->LeadService->getMarketSegment();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getLeads(Request $request)
    {
        try {
            $data = $this->LeadService->getLeads($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveNewLeads(Request $request)
    {
        try {
            $data = $this->LeadService->saveNewLeads($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function leadValidate(Request $request)
    {
        try {
            $data = $this->LeadService->leadValidate($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function verifyExistencePartner(Request $request)
    {
        try {
            $data = $this->LeadService->verifyExistencePartner($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function incriptionValidate(Request $request)
    {
        try {
            $data = $this->LeadService->verifyExistencePartner($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function qualifyLead(Request $request)
    {
        try {
            $data = $this->LeadService->qualifyLead($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
