<?php

namespace CRM\Factory;

use CRM\Traits\TQuery;
use Doctrine\ORM\EntityManager;

class CrmClassificacaoParceiroFactory {

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getRankingPartnerFactory () {

        $query = "SELECT * FROM TIPOCLASSIFICAPARC 
                  ORDER BY NMCLASSIFICAPARC ASC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $query);
    }

    public function insertNewRankingPartnerFactory ($params) {

        $sql = "INSERT INTO TIPOCLASSIFICAPARC (
            NRTPCLASSIFICAPARC, NRORG, NMCLASSIFICAPARC, 
            DTINCLUSAO, DTULTATU, NRORGINCLUSAO, 
            CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU)
            VALUES (
            :NRTPCLASSIFICAPARC, :NRORG, :NMCLASSIFICAPARC, 
            SYSDATE, SYSDATE, :NRORGINCLUSAO, :CDOPERINCLUSAO,
            :NRORGULTATU, :CDOPERULTATU)";

        return $this->connection->executeStatement($sql, $params);

    }

    public function updateNewRankingPartnerFactory ($params) {

        $sql = "UPDATE TIPOCLASSIFICAPARC 
                SET NRTPCLASSIFICAPARC = :NRTPCLASSIFICAPARC, 
                NRORG = :NRORG, 
                NMCLASSIFICAPARC = :NMCLASSIFICAPARC, 
                DTULTATU = SYSDATE, 
                NRORGINCLUSAO = :NRORGINCLUSAO, 
                NRORGULTATU = :NRORGULTATU, 
                CDOPERULTATU = :CDOPERULTATU
                WHERE NRTPCLASSIFICAPARC = :NRTPCLASSIFICAPARC
                AND NRORG = :NRORG";
        
        $this->connection->executeStatement($sql, $params);
    
    }

    public function deleteRankingPartnerFactory ($params) {

        $sql = "DELETE FROM TIPOCLASSIFICAPARC
                WHERE NRTPCLASSIFICAPARC = :NRTPCLASSIFICAPARC
                AND NRORG = :NRORG";

        $this->connection->executeStatement($sql, $params);
    }
}