<?php

namespace CRM\Factory;

use CRM\Traits\TQuery;
use Doctrine\ORM\EntityManager;

class CrmModoDeDivulgacaoFactory
{
    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getDisclosureModeFactory (){
        
        $sql = "SELECT NRORG, CDMODODIVULG, NMMODODIVULG, IDATIVO, IDRDSTATION 
                FROM MODODIVULG
                WHERE IDATIVO = 'S'
                ORDER BY NMMODODIVULG ASC";
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function insertNewDisclosureModeFactory ($params){
        $sql = "INSERT INTO MODODIVULG (
                CDMODODIVULG, NMMODODIVULG, DTULTATUMDIV, 
                NRORG, DTINCLUSAO, DTULTATU, 
                NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, 
                CDOPERULTATU, IDATIVO, IDRDSTATION    
                )
                VALUES (
                :CDMODODIVULG, :NMMODODIVULG, SYSDATE, 
                :NRORG, SYSDATE, SYSDATE, 
                :NRORGINCLUSAO, :CDOPERINCLUSAO, :NRORGULTATU, 
                :CDOPERULTATU, :IDATIVO, 'N'
                )";
        
        $this->connection->executeStatement($sql, $params);
    }

    public function updateDisclosureModeServiceFactory ($params) {
        $sql = "UPDATE MODODIVULG
                SET NMMODODIVULG = :NMMODODIVULG, 
                DTULTATUMDIV = SYSDATE, 
                NRORG = :NRORG, DTULTATU = SYSDATE, 
                NRORGULTATU = :NRORGULTATU, 
                CDOPERULTATU = :CDOPERULTATU, 
                IDATIVO = :IDATIVO
                WHERE CDMODODIVULG = :CDMODODIVULG
                AND   NRORG = :NRORG";

        $this->connection->executeStatement($sql, $params);
    }

    public function findRelationshipFactory ($params) {
        
        $sql = "SELECT COUNT (CDMODODIVULG) AS CDMODODIVULG FROM CRM_OPORTUNI 
                WHERE CDMODODIVULG = :CDMODODIVULG";

        return $this->connection->executeQuery($sql, $params)->fetchAllAssociative();

    }

    public function deleteDisclosureModeServiceFactory ($params) {
        $sql = "DELETE FROM MODODIVULG 
                WHERE CDMODODIVULG = :CDMODODIVULG";
        $this->connection->executeStatement($sql, $params);
    }
}