<?php

namespace CRM\Factory;

use CRM\Traits\TQuery;
use Doctrine\ORM\EntityManager;

class CrmRamodeAtividadeFactory
{
    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getBranchOfActivityFactory()
    {
        $sql = "SELECT RAMO.*, SEGM.DSSEGMER 
        FROM ATIVCLIENTE RAMO 
        LEFT JOIN SEGMERCADO SEGM 
        ON  RAMO.CDSEGMER = SEGM.CDSEGMER
        AND RAMO.NRORG = SEGM.NRORG 
        AND RAMO.IDATIVO = SEGM.IDATIVO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getFieldMarket()
    {
        $sql = "SELECT DSSEGMER, CDSEGMER FROM SEGMERCADO ORDER BY DSSEGMER ASC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function insertNewBranchFactory($params)
    {
        try {
            $sql = "INSERT INTO ATIVCLIENTE (
                CDATIVCLI,   DSATIVCLI,      CDSEGMER,
                DTULTATU,    CDNVATIVCLI,    CDARVATIVCLI,
                IDATIVO,     NRORG,          NRORGINCLUSAO,
                NRORGULTATU, CDOPERINCLUSAO, CDOPERULTATU,
                DTINCLUSAO
            )
            VALUES (
                :CDATIVCLI,   :DSATIVCLI,      :CDSEGMER,
                SYSDATE,      :CDNVATIVCLI,    :CDARVATIVCLI,
                :IDATIVO,     :NRORG,          :NRORGINCLUSAO,
                :NRORGULTATU, :CDOPERINCLUSAO, :CDOPERULTATU,
                SYSDATE
            )";

            $this->connection->executeStatement($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function updateNewBranchFactory($params)
    {
        $sql = "UPDATE ATIVCLIENTE
                SET DSATIVCLI    = :DSATIVCLI,
                    CDATIVCLI    = :CDATIVCLI,
                    CDSEGMER     = :CDSEGMER,
                    DTULTATU     = SYSDATE,
                    NRORGULTATU  = :NRORGULTATU,
                    CDOPERULTATU = :CDOPERULTATU,
                    IDATIVO      = :IDATIVO
                WHERE CDATIVCLI  = :CDATIVCLI";

        $this->connection->executeStatement($sql, $params);
    }

    public function deleteBranchOfActivityFactory($params)
    {
        $sql = "DELETE
                FROM ATIVCLIENTE
                WHERE CDATIVCLI IN (" . $params . ")";

        $this->connection->executeStatement($sql);
    }
}
